#include <LiquidCrystal.h>
#include <Servo.h>

#define PWM 11 //define dc motor
int motorPot;
int motorOut;

LiquidCrystal lcd(7, 6, 5, 4, 3, 2);

const int potPin[3] = {A0, A1, A2}; // Increase size if you are using more servos / Potentiometer pins
const int serPin[3] = {8, 9, 10}; // Increase size if you are using more servos / sevo pins
const int servoNum = 3;

struct ServoMotor{
  Servo servo;
  int lastValue = 0;
  int value;
};
ServoMotor ServoMotor[servoNum]; // Number of servos

void setup() {
  for(int i = 0; i < 3; i++){
    pinMode(potPin[i], INPUT);
    ServoMotor[i].servo.attach(serPin[i]);
    ServoMotor[i].value = analogRead(potPin[i]);
    ServoMotor[i].lastValue = ServoMotor[i].value;
  }
  Serial.begin(9600);
  lcd.begin(16, 2);
}

void lcDisplay() { //fuction that prints data to lcd screen
  lcd.setCursor(0, 0);
  for(int i = 0; i < servoNum; i++){
    lcd.print("S");
  lcd.print(i+1);
  lcd.print(": ");
  lcd.print(ServoMotor[i].value);
  lcd.print("  ");
    if (i == 1) 
      lcd.setCursor(0, 1);
  }
  delay(100);
}

void move() { //move function that moves servo motors based on potenciometer values
  for(int i = 0; i < servoNum; i++){
    int temp = abs(ServoMotor[i].lastValue - ServoMotor[i].value);
    if (temp > 40) { 
      ServoMotor[i].value = map(analogRead(potPin[i]), 0, 1023, 0, 180);
      ServoMotor[i].value = constrain(ServoMotor[i].value, 0, 180);
      ServoMotor[i].servo.write(ServoMotor[i].value);
      ServoMotor[i].lastValue = ServoMotor[i].value;
    }
  }
}

void motor() { //motor function that speeds up dc motor based on potenciometer values
  motorPot = analogRead(A5);
  motorOut = map(  motorPot, 0, 1023, 0, 255);
  analogWrite(PWM, motorOut);
}

void loop() {
  for(int i = 0; i < servoNum; i++){
    ServoMotor[i].value = analogRead(potPin[i]);  // Read potentiometer values for servo motors
  }
  motor();  // Update the dc motor based on potentiometer value
  move();   // Move servos based on potentiometer values
  lcDisplay();  // Update LCD display
}